<?php
namespace Planejamento\Logic\RelatorioCustos;

use Geral\Entities\Comprador;
use Geral\Entities\Dietpadr;
use Geral\Entities\Operador;
use Geral\Repositories\Servico;
use Geral\Util\Ambiente;
use Geral\Entities\Filial;
use Planejamento\Entities\Tipoprat;
use Geral\Entities\Lista;
use Geral\Util\DateUtil;
use \Geral\Util\Novocodigo;
use Planejamento\Logic\RelatorioCustos\TrabCardmes;
use Planejamento\Logic\RelatorioPlanejamento\RelatorioPlanejamentoLogic;

/**
 * Created by JetBrains PhpStorm.
 * User: maximiliansilva
 * Date: 19/03/12
 * Time: 08:57
 * To change this template use File | Settings | File Templates.
 */
class RelatorioCustoLogic {
    private $nrlista;
    CONST CDSERVFILI ='cdservfili';
    const CDDIETPAD = 'cddietpad';
    const CDTIPOPRATO = 'cdtipoprato';
    const CDCOMPRADOR = 'cdcomprador';
    const NAO = 'N';
    const CDFILIAL = 'cdfilial';
    const TODOS = 'A';
    const NENHUM = 'N';
    const TODAS = 'T';


    /**
     * Gera a lista de servicos por filial ou grupo de servico.
     *
     * @param integer  $nrorg      Numero da Organizacao.
     * @param integer  $cdfilial   Codigo da filial.
     * @param integer  $cdgrupserv Codigo do grupo de servico.
     *
     * @return string
     * @param array  $listaServicos .
     */
    public function geraListaServico(
        $nrorg, $cdfilial, $cdgrupserv = null, $listaServicos = null
    )
    {
        /* @var $servicos \Geral\Entities\Servico[] */
        $stListaServ = "";

        if ($cdgrupserv === null && $listaServicos === null) {
            $servicos = \Geral\Entities\Servico::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ? AND IDSERVATIV <> ?',
                array(
                    $nrorg,
                    $cdfilial,
                    self::NAO
                )
            );
            if (empty($servicos) === false) {
                $stListaServ = '_';
                foreach ($servicos as $servico) {
                    $stListaServ .= $servico->getCdservfili() . '_';
                }
            }
        } else {
            if (empty($listaServicos) === false) {

                $stListaServ = '_';
                foreach ($listaServicos as $listaServico) {
                    foreach ($listaServico as $indice => $cdServico) {
                        if ($indice == self::CDSERVFILI) {
                            $stListaServ .= $cdServico . '_';
                        }
                    }
                }

            } else {
                $servicos = \Geral\Entities\Servico::getObjectsByWhere(
                    'NRORG = ? AND CDFILIAL = ? AND CDGRUPSERV = ? AND IDSERVATIV <> ?',
                    array(
                        $nrorg,
                        $cdfilial,
                        $cdgrupserv,
                        self::NAO
                    )
                );
                if (empty($servicos) === false) {
                    $stListaServ = '_';
                    foreach ($servicos as $servico) {
                        $stListaServ .= $servico->getCdservfili() . '_';
                    }
                }
            }
        }


        return $stListaServ;

    }


    public function geraListaDeServicoPorFilial(
        $nrorg, $cdgrupfili = null, $listaFiliais = null, $listaServicos = null
    )
    {
        $window = tk_get_active_window_name();
        /* @var $servicos \Geral\Entities\Servico[] */
        $stListaServ = "";
        //Retorna todos os serviços.
        if (empty($cdgrupfili) === true && empty($listaFiliais) === true
            && empty($listaServicos) === true
        ) {

            if (empty($listaServicos) === false) {
                $stListaServ = '_';
                foreach ($listaServicos as $listaServico) {
                    if ($concatena === true) {
                        if (empty ($listaServico['listafili']) === false) {
                            $stListaServ .= $listaServico['listafili']
                                . $listaServico['cdservfili'] . '_';
                        } else {
                            $stListaServ .= $listaServico['cdfilial']
                                . $listaServico['cdservfili'] . '_';
                        }
                    } else {
                        $stListaServ .= $listaServico['cdservfili'] . '_';
                    }
                }

            } else {

                $servicos = Servico::consultaListaServicoGruposervico(
                    $nrorg, $cdfilial, $cdgrupserv
                );

                if (empty($servicos) === false) {
                    $stListaServ = '_';
                    foreach ($servicos as $servico) {
                        if ($concatena === true) {
                            $stListaServ
                                .= $servico['CDFILIAL'] . $servico['CDSERVFILI']
                                . '_';
                        } else {
                            $stListaServ .= $servico['CDSERVFILI'] . '_';
                        }
                    }
                }
            }
        } //Retorna os serviços por filial selecionada.
        else if (empty($cdgrupfili) === true && empty($listaFiliais) === false) {
            $stListaServ = '_';
            foreach ($listaFiliais as $ListaFili) {
                foreach ($ListaFili as $indice => $filial) {
                    if ($indice == 'cdfilial') {
                        $servicos = \Geral\Entities\Servico::getObjectsByWhere(
                            'NRORG = ? AND CDFILIAL = ?',
                            array(
                                $nrorg,
                                $filial
                            )
                        );

                        if (empty($servicos) === false) {
                            foreach ($servicos as $servico) {
                                if ($window == 'pla02703' || $window == 'pla02700') {
                                    $stListaServ .= $servico->getCdfilial()
                                        . $servico->getCdservfili() . '_';
                                } else {
                                    $stListaServ
                                        .= $servico->getCdservfili() . '_';
                                }
                            }
                        }
                    }
                }
            }
        } //Retorna os servi�os por agrupamento de filiais selecionado.
        else if (empty($cdgrupfili) === false) {
            /** @var $filialRepository \Geral\Repositories\Filial */
            $filialRepository = Filial::getRepository();
            $filiais = $filialRepository->consultaFilialPorGrupo(
                $nrorg, $cdgrupfili
            );

            if (empty($filiais) === false) {
                $stListaServ = '_';
                foreach ($filiais as $ListaFili) {
                    foreach ($ListaFili as $indice => $filial) {
                        if ($indice == 'CDFILIAL') {
                            $servicos = \Geral\Entities\Servico::getObjectsByWhere(
                                'NRORG = ? AND CDFILIAL = ?',
                                array(
                                    $nrorg,
                                    $filial
                                )
                            );

                            if (empty($servicos) === false) {
                                foreach ($servicos as $servico) {
                                    if ($window == 'pla02703'
                                        || $window == 'pla02700'
                                    ) {
                                        $stListaServ
                                            .= $servico->getCdfilial()
                                            . $servico->getCdservfili()
                                            . '_';
                                    } else {
                                        $stListaServ
                                            .= $servico->getCdservfili() . '_';
                                    }
                                }
                            }
                        }
                    }
                }
            }

            return $stListaServ;
        }
    }


    public function geraListaDeFiliais($nrorg, $cdgrupfili, $listaFiliais)
    {
        /* @var $filiais Filial */
        $stListaFili = "";

        //Grupo de Filiais não selecionado e Filial = "All" -> retorna todas as filiais
        if (empty($cdgrupfili) === true
            && ($listaFiliais === self::NENHUM . '' || $listaFiliais === self::TODOS)
        ) {
            $filiais = Filial::getObjectsByWhere('NRORG = ?', array($nrorg,));
            if (empty($filiais) === false) {
                $stListaFili = '_';
                foreach ($filiais as $filial) {
                    $stListaFili .= $filial->getCdfilial() . '_';
                }
            }
            //Grupo de Filiais selecionado e Filial = "All" -> retorna as filiais daquele grupo
        } else {
            if (empty($cdgrupfili) === false
                && ($listaFiliais === self::NENHUM || $listaFiliais === self::TODOS)
            ) {
                /** @var $filialRepository \Geral\Repositories\Filial */
                $filialRepository = Filial::getRepository();
                $filiais = $filialRepository->consultaFilialPorGrupo(
                    $nrorg, $cdgrupfili
                );

                if (empty($filiais) === false) {
                    $stListaFili = '_';
                    foreach ($filiais as $filial) {
                        foreach ($filial as $ind => $cdFil) {
                            if ($ind == 'CDFILIAL') {
                                $stListaFili .= $cdFil . '_';
                            }
                        }
                    }
                }
                //Filial selecionada
            } else {
                $stListaFili = '_';
                foreach ($listaFiliais as $listaFilial) {
                    foreach ($listaFilial as $indice => $cdFilial) {
                        if ($indice == self::CDFILIAL) {
                            $stListaFili .= $cdFilial . '_';
                        }
                    }
                }
            }
        }
        return $stListaFili;
    }


    /**
     * Metodo para gerar lista de Filais por grupo de filial.
     *
     * @param integer $nrorg      Numero da organizacao.
     * @param integer $cdgrupfili Codigo do agrupamento de filial.
     *
     * @return string
     */
    public function geraListaFilial($nrorg, $cdgrupfili)
    {
        $filiais = \Geral\Repositories\Servico::consultaListaFilialGrupofilial(
            $nrorg, $cdgrupfili
        );

        $stListaFili = "_";
        if (is_array($filiais)) {
            foreach ($filiais as $filial) {
                $stListaFili .= $filial['CDFILIAL'] . "_";
            }
        }

        return $stListaFili;
    }


    /**
     * Metodo para inserir lista de filiais por agrupamento.
     *
     * (Não esta sendo usado)
     *
     * @param integer $nrorg      Numero da organizacao.
     * @param integer $cdgrupfili Codigo do agrupamento de filial.
     * @param bool    $todas
     *
     * @return number|string
     */
    public function insereListaFiliaisPorAgrupamento(
        $nrorg, $cdgrupfili = null, $todas = false
    ) {
        if (!empty($cdgrupfili)) {
            $filiais = \VendingMachine\Entities\Filgrupfili::getObjectsByWhere(
                'NRORG = ? AND CDGRUPFILI = ?',
                array($nrorg, $cdgrupfili)
            );
            $nrlista = Lista::novoCodigo();

            foreach ($filiais as $filial) {
                /* @var $filial \VendingMachine\Entities\Filgrupfili */
                Lista::insere($nrlista, $filial->getCdfilial(), $nrorg);
            }
        }
        if (empty($cdgrupfili) && $todas == false) {
            $nrlista = 'T';
        } else {
            $filiais = Filial::getObjectsByWhere('NRORG = ?', array($nrorg));
            $nrlista = Lista::novoCodigo();
            foreach ($filiais as $filial) {
                /* @var $filial \Geral\Entities\Lista */
                Lista::insere($nrlista, $filial->getCdfilial(), $nrorg);
            }
        }
        return $nrlista;
    }

    /**
     * Insere lista das filiais por agrupamento de filial
     *
     * @param String $nrorg      Organização
     * @param String $cdfilial   Unidade
     * @param String $cdgrupfili Grupo de unidade
     *
     * @author matthaeuscarvalho
     *
     * @return int|string Número da lista
     */
    public static function insereListaFiliais(
        $nrorg, $cdfilial, $cdgrupfili
    ) {
        $nrlista = Lista::novoCodigo();

        if (!empty($cdgrupfili) && $cdfilial == self::TODOS) {
            $filiais = \VendingMachine\Entities\Filgrupfili::getObjectsByWhere(
                'NRORG = ? AND CDGRUPFILI = ?',
                array($nrorg, $cdgrupfili)
            );
            foreach ($filiais as $filial) {
                /** @var $filial \VendingMachine\Entities\Filgrupfili */
                Lista::insere($nrlista, $filial->getCdfilial(), $nrorg);
            }
        } elseif (is_array($cdfilial)) {
            foreach ($cdfilial as $filial) {
                Lista::insere($nrlista, $filial['cdfilial'], $nrorg);
            }
        } elseif (empty($cdgrupfili) && $cdfilial == self::TODOS) {
            $filiais = \VendingMachine\Entities\Filgrupfili::getObjectsByWhere(
                'NRORG = ?', array($nrorg)
            );
            foreach ($filiais as $filial) {
                /** @var $filial \VendingMachine\Entities\Filgrupfili */
                Lista::insere($nrlista, $filial->getCdfilial(), $nrorg);
            }
        }
        return $nrlista;
    }

    //Danilo Inicio
    public static function verificaParamServico($grupServico, $servico)
    {
        if ($grupServico == self::TODOS) {
            if ($servico != self::TODOS) {
                $stListaServ
                    = \View\RelatorioCustos\Facade::geraListaServicoGruposervico();
            } else {
                $stListaServ = 'T';
            }
            tk_set_field_value('LISTAGRUPSERV', 'T');
        } else {
            $stListaServ
                = \View\RelatorioCustos\Facade::geraListaServicoGruposervico();
        }

        return $stListaServ;

    }

    public static function trataTipoProd(array $field)
    {

        $idmateprim = '';
        $idnestocaveis = '';
        $idconsperc ='';
        $idconsfixo = '';

        foreach($field as $lista)
            $tiposProd = explode(',',$lista);

        foreach($tiposProd as $tipoProd){
            if($tipoProd == 'MATPRIMA')
                $idmateprim = 'S';
            else if($tipoProd == 'NAOESTOC')
                $idnestocaveis = 'S';
            else if($tipoProd == 'CONSPERCAP')
                $idconsperc = 'S';
            else if($tipoProd == 'CONSFIXO')
                $idconsfixo = 'S';
        }

        tk_set_field_value('IDMATEPRIM', $idmateprim);
        tk_set_field_value('IDNESTOCAVEIS', $idnestocaveis);
        tk_set_field_value('IDCONSPERC', $idconsperc);
        tk_set_field_value('IDCONSFIXO', $idconsfixo);
    }


    public static function  geraListaGrupoServico($cdGrupServ)
    {

        $stListaGrupServ = '';
        if (is_array($cdGrupServ)) {
            foreach ($cdGrupServ as $grupServ) {
                $stListaGrupServ .= $grupServ['cdgrupserv'] . ',';
            }
        } else {
            return $cdGrupServ;
        }

        $stListaGrupServ = rtrim($stListaGrupServ, ',');

        return $stListaGrupServ;
    }


    public function  geraListaFiliais($cdFilial)
    {

        $stListaFilial = '';
        if (is_array($cdFilial)) {
            foreach ($cdFilial as $grupFilial) {
                $stListaFilial .= $grupFilial['cdfilial'] . ',';
            }
        } else {
            return $cdFilial;
        }

        $stListaFilial = rtrim($stListaFilial, ',');

        return $stListaFilial;
    }


    public function geraListaServicoGrupofilial(
        $nrorg, $cdfilial, $cdgrupserv = 'A', $listaServicos = null
    )
    {
        $stListaServ = "";
        $concatena = false;
        $listaFilial = tk_get_field_value('LISTAFILI');

        if ($cdgrupserv == self::TODOS && $listaServicos === null) {
            if (empty($listaFilial) === false) {
                $cdfilial = tk_get_field_value('LISTAFILI');
                $concatena = true;
            }

            $servicos = Servico::consultaListaServicoGruposervico(
                $nrorg, $cdfilial, $cdgrupserv
            );

            if (empty($servicos) === false) {
                $stListaServ = '_';
                foreach ($servicos as $servico) {
                    if ($concatena === true)
                        $stListaServ
                            .= $servico['CDFILIAL'] . $servico['CDSERVFILI'] . '_';
                    else
                            {
                                $stListaServ .= $servico['CDSERVFILI'] . '_';
                            }
                }
            }
        } else {
            if (empty($listaFilial) === false) {
                $cdfilial = tk_get_field_value('LISTAFILI');
                $concatena = true;
            }

            if (empty($listaServicos) === false) {
                $stListaServ = '_';
                foreach ($listaServicos as $listaServico)
                    if ($concatena === true)
                        $stListaServ
                            .=
                            $listaServico['listafili'] . $listaServico['cdservfili']
                                . '_';
                    else
                        $stListaServ .= $listaServico['cdservfili'] . '_';

            } else {

                $servicos = Servico::consultaListaServicoGruposervico(
                    $nrorg, $cdfilial, $cdgrupserv
                );

                if (empty($servicos) === false) {
                    $stListaServ = '_';
                    foreach ($servicos as $servico) {
                        if ($concatena === true)
                            $stListaServ
                                .=
                                $servico['CDFILIAL'] . $servico['CDSERVFILI'] . '_';
                        else
                            $stListaServ .= $servico['CDSERVFILI'] . '_';
                    }
                }
            }
        }

        return $stListaServ;

    }
    //Danilo Fim

    /**
     * Metodo para inserir Lista de servicos.
     *
     * @param integer $nrorg      Numero da organizacao.
     * @param integer $cdfilial   Codigo da filial.
     * @param null    $cdgrupfili Codigo do agrupamento de filial.
     * @param null    $cdgrupserv Codigo do grupo de servicos.
     *
     * @return number|string
     */
    public function insereServicos(
        $nrorg, $cdfilial, $cdgrupfili = null, $cdgrupserv = null
    )
    {
        $nrlista = "";
        /* @var $filiais Filial */
        /* @var $servicos \Geral\Entities\Servico[] */
        $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
        $connection->beginTransaction();
        if (empty($cdgrupfili) === false) {
            $filiais = Filial::findByNrorgAndCdgrupfili(
                $nrorg, $cdgrupfili
            );
            foreach ($filiais as $filial) {
                self::insereServicos(
                    $nrorg, $filial->getCdfilial(), null, $cdgrupserv
                );
            }
        } else {
            if (empty($cdfilial) === false) {
                $nrlista = isset($this->nrlista)
                    ? $this->nrlista
                    : $this->nrlista = \Geral\Util\Novocodigo::geraCodigo(
                        \Geral\Util\Ambiente::getNrorg(), 'LISTA'
                    );

                if (empty($cdgrupserv)) {
                    $servicos = \Geral\Entities\Servico::findByNrorgAndCdfilial(
                        $nrorg, $cdfilial
                    );
                } else {
                    $servicos
                        = \Geral\Entities\Servico::findByNrorgAndCdfilialAndCdgrupserv(
                        $nrorg, $cdfilial, $cdgrupserv
                    );
                }

                foreach ($servicos as $servico) {
                    $entidade = new Lista();
                    $entidade->setCdlista($cdfilial . $servico->getCdservfili());
                    $entidade->setNrlista($nrlista);
                    $entidade->setNrorg($nrorg);
                    $entidade->persist();
                }

            } else {
                $nrlista = 'T';
            }
        }
        \Setforms2\Shared\Registry::getEntityManager()->flush();
        $connection->commit();
        return $nrlista;
    }

    /**
     * Executa procedure por filiais.
     *
     * @param array|string $params     Parametros da procedure.
     * @param integer      $cdgrupfili Codigo do agrupamento de filiais.
     * @param null         $cdgrupserv Codigo do grupo de servicos.
     * @param null         $cdservfili Codigo do servico.
     *
     * @return void
     */
    public function executaProcedureFiliais(
        array $params, $cdgrupfili, $cdgrupserv = null, $cdservfili = null
    )
    {
        /* @var $params \VendingMachine\Entities\Filgrupfili[] */
        $filiais
            =
        $filiais = \VendingMachine\Entities\Filgrupfili::findByNrorgAndCdgrupfili(
            $params->getNrorg(), $cdgrupfili
        );

        foreach ($filiais as $filial) {
            if (empty($cdservfili) === false) {
                $servico
                    = \Geral\Entities\Servico::findByNrorgAndCdservfiliAndCdfilial(
                    $params['P_NRORG'], $cdservfili, $filial
                );
                $servicos = ($servico === false) ? '_' : $cdservfili;
            } else {
                $servicos = $this->geraListaServico(
                    $params['P_NRORG'], $filial, $cdgrupserv
                );
            }

            \Planejamento\Logic\ConsumoPlanejadoRel\ConsumoPlanejadoRel::ProcedureConsPlan(
                $filial, $params['DATAINICIAL'], $params['DATAFINAL'],
                $params['NRORG'],
                $params['OPERADOR'], $servicos, $params['IDARQUIVO'],
                $params['IDPRODUTOS'], $params['IDSEPPRATO'],
                $params['PREACRESCIMO'],
                $params['IDARREDOND'], $params['CDPRODUTOINI'],
                $params['CDPRODUTOFIN'], $params['STDTINICIAL'],
                $params['STDTFINAL'], $params['NRCONSPLAN']
            );
        }
    }

    public function geraListaNutrientes($nrorg)
    {
        $listanutrientes = "";

        /* @var $nutrientes \Geral\Entities\Nutriente[] */
        $nutrientes = \Geral\Entities\Nutriente::getObjectsByWhere(
            'NRORG = ?',
            array($nrorg)
        );

        foreach ($nutrientes as $nutriente) {
            $listanutrientes .= $nutriente->getCdnutriente() . '_';
        }

        return $listanutrientes;

    }

    public function tratarListaServico($servico, $grupoServico)
    {

        //Todos os serviços, sem escolher grupo.
        if ($servico == self::TODOS && empty($grupoServico) === true) {
            $stListaServ = "T";
        } //Demais combinações.
        else {
            $relatorioCusto = new \View\RelatorioCustos\Facade();
            $stListaServ = $relatorioCusto->geraListaServico();
        }

        return $stListaServ;

    }

    public static function mtk_showMonthInicial()
    {
        $date = tk_get_field_value('DTINICIAL');
        if ($date == true) {
            $date = new \TkDateTime($date);
            tk_set_field_value(
                'MESINICIAL', ucfirst($date->get(\TkDateTime::MONTH_NAME))
            );
        } else {
            tk_set_field_value('MESINICIAL', '');
        }
    }

    public static function mtk_showMonthFinal()
    {
        $date = tk_get_field_value('DTFINAL');

        if ($date == true) {
            $date = new \TkDateTime($date);
            tk_set_field_value(
                'MESFINAL', ucfirst($date->get(\TkDateTime::MONTH_NAME))
            );
        } else {
            tk_set_field_value('MESFINAL', '');
        }
    }


    public static function geraListaDieta()
    {
        $dietas = tk_get_field_value('CDDIETPAD');
        $nrorg = Ambiente::getNrorg();

        // Se escolher todas as dietas
        if ($dietas == self::TODOS) {
            $dieta = Dietpadr::getObjectsByWhere(
                'NRORG = ?', array($nrorg)
            );
            if (empty($dieta) === false) {
                $stListaDieta = '_';

                /** @var $diet Dietpadr */
                foreach ($dieta as $diet) {
                    $stListaDieta .= $diet->getCddietpad() . '_';
                }
            }

            // Se selecionar uma dieta especifica.
        } else {
            if (is_array($dietas) === true) {
                $stListaDieta = '_';
                foreach ($dietas as $listaDiet) {
                    foreach ($listaDiet as $indice => $cdDiet) {
                        if ($indice == self::CDDIETPAD) {
                            $stListaDieta .= $cdDiet . '_';
                        }
                    }
                }
            } else {
                $stListaDieta = '';
            }
        }

        return $stListaDieta;
    }

    public static function geraListaPrato()
    {
        $pratos = tk_get_field_value('CDTIPOPRATO');
        $nrorg = Ambiente::getNrorg();

        // Se escolher todos os pratos
        if ($pratos == self::TODOS) {
            $prato = Tipoprat::getObjectsByWhere(
                'NRORG = ?', array($nrorg)
            );
            if (empty($prato) === false) {
                $stListaPrato = '_';

                /** @var $pra Tipoprat */
                foreach ($prato as $pra) {
                    $stListaPrato .= $pra->getCdtipoprat() . '_';
                }
            }

            // Se selecionar um prato especifico.
        } else {
            if (is_array($pratos) === true) {
                $stListaPrato = '_';
                foreach ($pratos as $listaPra) {
                    foreach ($listaPra as $indice => $cdPra) {
                        if ($indice == self::CDTIPOPRATO) {
                            $stListaPrato .= $cdPra . '_';
                        }
                    }
                }
            } else {
                $stListaPrato = '';
            }
        }

        return $stListaPrato;
    }


    public static function geraListaComprador()
    {
        $compradores = tk_get_field_value('CDCOMPRADOR');
        $nrorg = Ambiente::getNrorg();

        // Se escolher todos os compradores
        if ($compradores == self::TODOS) {
            $comprador = Comprador::getObjectsByWhere(
                'NRORG = ?', array($nrorg)
            );
            if (empty($comprador) === false) {
                $stListaComprador = '_';

                /** @var $comprad Comprador */
                foreach ($comprador as $comprad) {
                    $stListaComprador .= $comprad->getCdoperador() . '_';
                }
            }

            // Se selecionar um comprador especifico.
        } else {
            if (is_array($compradores) === true) {
                $stListaComprador = '_';
                foreach ($compradores as $listaComprad) {
                    foreach ($listaComprad as $indice => $cdComprad) {
                        if ($indice == self::CDCOMPRADOR) {
                            $stListaComprador .= $cdComprad . '_';
                        }
                    }
                }
            } else {
                $stListaComprador = '';
            }
        }

        return $stListaComprador;
    }

    /**
     * Insere lista de operadores de um multisearch
     *
     * @param String $nrorg      Organização
     * @param String $cdoperador Operador
     *
     * @author   matthaeuscarvalho
     *
     * @return int|string Núnero da lista
     */
    public static function insereListaOperadorMultisearch($nrorg, $cdoperador)
    {
        $nrlista = Lista::novoCodigo();
        if ($cdoperador == self::TODOS) {
            /* @var $operadores Operador */
            $operadores = Operador::getObjectsByWhere('NRORG = ?', array($nrorg));
            foreach ($operadores as $operador) {
                /* @var $operador Operador */
                Lista::insere($nrlista, $operador->getCdoperador(), $nrorg);
            }
        }
        elseif (is_array($cdoperador)) {
            foreach ($cdoperador as $operador) {
                Lista::insere($nrlista, $operador['cdoperador'], $nrorg);
            }
        }
        return $nrlista;
    }

    public function insereOperador($nrorg, $cdoperador = null)
    {
        $nrlista = Lista::novoCodigo();
        if (empty($cdoperador)) {
            /* @var $operadores Comprador */
            $operadores = Comprador::findByNrorg($nrorg);

        } elseif (!empty($cdoperador)) {
            /* @var $operadores Comprador */
            $operadores = Comprador::findByNrorgAndCdoperador(
                $nrorg, $cdoperador
            );
        }
        /* @var $operadores Comprador */
        foreach ($operadores as $operador) {
            Lista::insere(
                $nrlista, $operador->getCdoperador(), $nrorg
            );
        }
        return $nrlista;
    }

    public static function EmissaodoCardapioMes(
        $nrorg, $window, $servico, $impcomen, $dtmesinic, $dtmesfim,
        $idnomefant, $idimpdiassem, $qtcoluna, $report
    )
    {
        if ($servico == self::TODOS
            && ($report == 'PLA02702'
                || $report ==
                    'PLA02703')
        ) {
            $listaServico = 'T';
        } else {
            $listaServico
                = RelatorioPlanejamentoLogic::geraListaServicoConcatFiliais();
        }
        tk_set_field_value('LISTASERV', $listaServico);
        $nrlista = NovoCodigo::geraCodigo($nrorg, 'LISTA');
        $servicoConcat = explode('_', $listaServico);
        //retira o primeiro elemento do array
        unset($servicoConcat[0]);
        //retira o ultimo elemento do array
        array_pop($servicoConcat);
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();

        try {
            foreach ($servicoConcat as $servico) {
                $lista = new Lista();
                $lista->setNrlista($nrlista);
                $lista->setCdlista($servico);
                $lista->setNrorg($nrorg);
                $lista->setDtinclusao(DateUtil::getDataAtual());
                $lista->setCdoperinclusao(Ambiente::getCdOperador());
                $lista->setDtultatu(DateUtil::getDataAtual());
                $lista->persist();
            }

            $connection->flush();
            $connection->commit();

        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
        tk_set_field_value('NRLISTASERV', $nrlista);
        tk_set_field_value('NRSEQTRABCARD', $nrlista);

        tk_set_context_vars('NRLISTA', tk_get_active_window_name(), $nrlista);

        if ($window == 'pla02704') {
            $qtcoluna = 10;
        }

        if ($window == 'pla02705') {
            if ($impcomen == 1 || $impcomen == 2) {
                tk_set_field_value('IDIMPCOMEN', 1);
            } else {
                tk_set_field_value('IDIMPCOMEN', 0);
            }
        }
        if (tk_get_field_value('CDDIETA') == '') {
            tk_set_field_value('CDDIETA', 'T');
        }
        // Procedure para prenncher a tabela de trabalho TRABCARDMES
        $setexec = new TrabCardmes;
        $setexec->ProcedureTrabCardames(
            $nrlista, $nrlista, $dtmesinic, $dtmesfim,
            $idnomefant, $idimpdiassem, $qtcoluna
        );

    }

    /**
     * @param $nrorg
     * @param $cdfilial
     * @param $cdgrupfili
     *
     * @return null
     */
    public static function geraListaFili($nrorg, $cdfilial, $cdgrupfili)
    {
        if (is_array($cdfilial) === true
            || (empty($cdgrupfili) === false && is_array($cdfilial) === true)
        ) {
            $stListaFili = '';
            $lista = '';
            foreach ($cdfilial as $filial) {
                $stListaFili .= $filial['cdfilial'] . ',';
                $lista = rtrim($stListaFili, ",");
            }
            tk_set_field_value('LISTAFILI', $lista);
            tk_set_env_var('CDFILIAL_SEARCH', $lista);
        } elseif (empty($cdgrupfili) === false && $cdfilial == self::TODOS) {
            /** @var $filialRepository \Geral\Repositories\Filial */
            $filialRepository = Filial::getRepository();
            $filiais = $filialRepository->consultaFilialPorGrupo(
                $nrorg, $cdgrupfili
            );

            if (empty($filiais) === false) {
                $stListaFili = '';
                foreach ($filiais as $filial) {
                    foreach ($filial as $ind => $cdFil) {
                        if ($ind == 'CDFILIAL') {
                            $stListaFili .= $cdFil . ',';
                        }
                    }
                }

                $lista = rtrim($stListaFili, ",");
                tk_set_field_value('LISTAFILI', $lista);
                tk_set_env_var('CDFILIAL_SEARCH', $lista);
            }
        } elseif ($cdfilial == self::NENHUM) {
            tk_set_env_var('CDFILIAL_SEARCH', self::NENHUM);
            tk_set_field_value('LISTAFILI', null);
        } else {
            tk_set_env_var('CDFILIAL_SEARCH', self::TODOS);
            tk_set_field_value('LISTAFILI', self::TODAS);
        }
    }

    /**
     * Realiza o concatenamento de filiais com os serviços de acordo com o que foi
     * selecionado nos multisearchs de Unidade e Serviço
     *
     * Função utilizada na tela de Exportação da configuração padrão.
     * @param $nrorg
     * @param $servico
     * @param $filial
     *
     * @return null
     */
    public static function concatenaFilialServico($nrorg, $servico, $filial){
        if ($filial == 'N') {
            tk_abort(tk_get_message_by_name('msg_ger04102_000_Filial_N'));
        } else {
            if ($filial == 'A') {
                if ($servico === 'A') {
                    /**
                     * Busca todos os serviços da tabela
                     * @var  $servicos \Geral\Entities\Servico[]
                     */
                    $servicos = \Geral\Entities\Servico::getObjectsByWhere(
                        'NRORG = ?', array($nrorg)
                    );
                    $listaConcatenada = '_';
                    foreach ($servicos as $servico) {
                        $listaConcatenada .= $servico->getCdfilial() . $servico->getCdservfili(). '_';
                    }
                    tk_set_context_vars('LISTAFILISERV', 'win_ger04106_000', $listaConcatenada);
                } else {
                    if ($servico === 'N') {
                        tk_abort(
                            tk_get_message_by_name('msg_ger04102_000_Servico_N')
                        );
                    } else {
                        $listaConcatenada = '_';
                        foreach ($servico as $servfili) {
                            $listaConcatenada .= $servfili['cdfilial'] . $servfili['cdservfili']. '_';
                        }
                        tk_set_context_vars('LISTAFILISERV', 'win_ger04106_000', $listaConcatenada);
                    }
                }
            } else {
                foreach ($filial as $fili) {
                    if ($servico === 'A') {
                        /**
                         * Busca a filial e os seus respectivos serviços
                         * @var  $servicos \Geral\Entities\Servico[]
                         */
                        $servicos = \Geral\Entities\Servico::getObjectsByWhere(
                            'CDFILIAL = ? AND NRORG = ? AND HRINICATEN IS NOT NULL',
                            array($fili['cdfilial'], $nrorg)
                        );
                        $listaConcatenada = '_';
                        foreach ($servicos as $serv) {
                            $listaConcatenada
                                .= $serv->getCdfilial() . $serv->getCdservfili(). '_';
                        }
                        tk_set_context_vars('LISTAFILISERV', 'win_ger04106_000', $listaConcatenada);
                    } else {
                        if ($servico === 'N') {
                            tk_abort(
                                tk_get_message_by_name(
                                    'msg_ger04102_000_Servico_N'
                                )
                            );
                        } else {
                            $listaConcatenada = '_';
                            foreach ($servico as $servfili) {
                                $listaConcatenada .= $servfili['cdfilial'] . $servfili['cdservfili']. '_';
                            }
                            tk_set_context_vars('LISTAFILISERV', 'win_ger04106_000', $listaConcatenada);
                        }
                    }
                }
            }
        }
    }
}