/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MESA                                                     */
/* Tabela : MESA                                                              */
/*                                                                            */
/* Criao:                                                                   */
/* 26/06/2007 - FELIPE H.                                                     */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MESA'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_MESA
GO

CREATE TRIGGER DTULTATU_MESA
ON MESA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
               (SELECT 'MESA',CDFILIAL, 'CDFILIAL='  +CDFILIAL + ';' +'NRMESA='+ NRMESA +
                       ';' +'CDLOJA='+ CDLOJA+ ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))FROM DELETED);

   END
   ELSE BEGIN
      UPDATE MESA
      SET DTULTATUMESA = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(MESA.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0))AND
            (ISNULL(MESA.CDLOJA,0)   = ISNULL(INSERTED.CDLOJA,0))AND
            (ISNULL(MESA.NRMESA,0)   = ISNULL(INSERTED.NRMESA,0));
   END;
END;
GO

UPDATE MESA SET DTULTATUMESA = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUMESA IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUMESA' and
            type = 'D')
   ALTER TABLE MESA DROP CONSTRAINT DEFAULT_DTULTATUMESA
GO

ALTER TABLE MESA ADD CONSTRAINT DEFAULT_DTULTATUMESA
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUMESA
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_MESA','4.11.210';
GO

